# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class Service(pulumi.CustomResource):
    cassandra: pulumi.Output[dict]
    cassandra_user_config: pulumi.Output[dict]
    cloud_name: pulumi.Output[str]
    components: pulumi.Output[list]
    elasticsearch: pulumi.Output[dict]
    elasticsearch_user_config: pulumi.Output[dict]
    grafana: pulumi.Output[dict]
    grafana_user_config: pulumi.Output[dict]
    influxdb: pulumi.Output[dict]
    influxdb_user_config: pulumi.Output[dict]
    kafka: pulumi.Output[dict]
    kafka_connect: pulumi.Output[dict]
    kafka_connect_user_config: pulumi.Output[dict]
    kafka_user_config: pulumi.Output[dict]
    maintenance_window_dow: pulumi.Output[str]
    maintenance_window_time: pulumi.Output[str]
    mysql: pulumi.Output[dict]
    mysql_user_config: pulumi.Output[dict]
    pg: pulumi.Output[dict]
    pg_user_config: pulumi.Output[dict]
    plan: pulumi.Output[str]
    project: pulumi.Output[str]
    project_vpc_id: pulumi.Output[str]
    redis: pulumi.Output[dict]
    redis_user_config: pulumi.Output[dict]
    service_host: pulumi.Output[str]
    service_integrations: pulumi.Output[list]
    service_name: pulumi.Output[str]
    service_password: pulumi.Output[str]
    service_port: pulumi.Output[float]
    service_type: pulumi.Output[str]
    service_uri: pulumi.Output[str]
    service_username: pulumi.Output[str]
    state: pulumi.Output[str]
    termination_protection: pulumi.Output[bool]
    def __init__(__self__, resource_name, opts=None, cassandra=None, cassandra_user_config=None, cloud_name=None, elasticsearch=None, elasticsearch_user_config=None, grafana=None, grafana_user_config=None, influxdb=None, influxdb_user_config=None, kafka=None, kafka_connect=None, kafka_connect_user_config=None, kafka_user_config=None, maintenance_window_dow=None, maintenance_window_time=None, mysql=None, mysql_user_config=None, pg=None, pg_user_config=None, plan=None, project=None, project_vpc_id=None, redis=None, redis_user_config=None, service_integrations=None, service_name=None, service_type=None, termination_protection=None, __props__=None, __name__=None, __opts__=None):
        """
        Create a Service resource with the given unique name, props, and options.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        
        The **cassandra_user_config** object supports the following:
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `migrateSstableloader` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
        
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **elasticsearch** object supports the following:
        
          * `kibanaUri` (`pulumi.Input[str]`)
        
        The **elasticsearch_user_config** object supports the following:
        
          * `customDomain` (`pulumi.Input[str]`)
          * `disableReplicationFactorAdjustment` (`pulumi.Input[str]`)
          * `elasticsearch` (`pulumi.Input[dict]`)
        
            * `actionAutoCreateIndexEnabled` (`pulumi.Input[str]`)
            * `actionDestructiveRequiresName` (`pulumi.Input[str]`)
            * `httpMaxContentLength` (`pulumi.Input[float]`)
            * `indicesFielddataCacheSize` (`pulumi.Input[float]`)
            * `indicesMemoryIndexBufferSize` (`pulumi.Input[float]`)
            * `indicesQueriesCacheSize` (`pulumi.Input[float]`)
            * `indicesQueryBoolMaxClauseCount` (`pulumi.Input[float]`)
            * `reindexRemoteWhitelists` (`pulumi.Input[list]`)
            * `threadPoolAnalyzeQueueSize` (`pulumi.Input[float]`)
            * `threadPoolAnalyzeSize` (`pulumi.Input[float]`)
            * `threadPoolForceMergeSize` (`pulumi.Input[float]`)
            * `threadPoolGetQueueSize` (`pulumi.Input[float]`)
            * `threadPoolGetSize` (`pulumi.Input[float]`)
            * `threadPoolIndexQueueSize` (`pulumi.Input[float]`)
            * `threadPoolIndexSize` (`pulumi.Input[float]`)
            * `threadPoolSearchQueueSize` (`pulumi.Input[float]`)
            * `threadPoolSearchSize` (`pulumi.Input[float]`)
            * `threadPoolSearchThrottledQueueSize` (`pulumi.Input[float]`)
            * `threadPoolSearchThrottledSize` (`pulumi.Input[float]`)
            * `threadPoolWriteQueueSize` (`pulumi.Input[float]`)
            * `threadPoolWriteSize` (`pulumi.Input[float]`)
        
          * `elasticsearchVersion` (`pulumi.Input[str]`)
          * `indexPatterns` (`pulumi.Input[list]`)
        
            * `maxIndexCount` (`pulumi.Input[float]`)
            * `pattern` (`pulumi.Input[str]`)
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `kibana` (`pulumi.Input[dict]`)
        
            * `elasticsearchRequestTimeout` (`pulumi.Input[float]`)
            * `enabled` (`pulumi.Input[bool]`)
            * `maxOldSpaceSize` (`pulumi.Input[float]`)
        
          * `maxIndexCount` (`pulumi.Input[float]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `elasticsearch` (`pulumi.Input[str]`)
            * `kibana` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `elasticsearch` (`pulumi.Input[str]`)
            * `kibana` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `recoveryBasebackupName` (`pulumi.Input[str]`)
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **grafana_user_config** object supports the following:
        
          * `alertingEnabled` (`pulumi.Input[str]`)
          * `alertingErrorOrTimeout` (`pulumi.Input[str]`)
          * `alertingNodataOrNullvalues` (`pulumi.Input[str]`)
          * `allowEmbedding` (`pulumi.Input[str]`)
          * `authGithub` (`pulumi.Input[dict]`)
        
            * `allowSignUp` (`pulumi.Input[str]`)
            * `allowedOrganizations` (`pulumi.Input[list]`)
            * `clientId` (`pulumi.Input[str]`)
            * `clientSecret` (`pulumi.Input[str]`)
            * `teamIds` (`pulumi.Input[list]`)
        
          * `authGitlab` (`pulumi.Input[dict]`)
        
            * `allowSignUp` (`pulumi.Input[str]`)
            * `allowedGroups` (`pulumi.Input[list]`)
            * `apiUrl` (`pulumi.Input[str]`)
            * `authUrl` (`pulumi.Input[str]`)
            * `clientId` (`pulumi.Input[str]`)
            * `clientSecret` (`pulumi.Input[str]`)
            * `tokenUrl` (`pulumi.Input[str]`)
        
          * `authGoogle` (`pulumi.Input[dict]`)
        
            * `allowSignUp` (`pulumi.Input[str]`)
            * `allowedDomains` (`pulumi.Input[list]`)
            * `clientId` (`pulumi.Input[str]`)
            * `clientSecret` (`pulumi.Input[str]`)
        
          * `cookieSamesite` (`pulumi.Input[str]`)
          * `customDomain` (`pulumi.Input[str]`)
          * `dashboardsVersionsToKeep` (`pulumi.Input[float]`)
          * `dataproxySendUserHeader` (`pulumi.Input[str]`)
          * `dataproxyTimeout` (`pulumi.Input[float]`)
          * `disableGravatar` (`pulumi.Input[str]`)
          * `editorsCanAdmin` (`pulumi.Input[str]`)
          * `externalImageStorage` (`pulumi.Input[dict]`)
        
            * `access_key` (`pulumi.Input[str]`)
            * `bucketUrl` (`pulumi.Input[str]`)
            * `provider` (`pulumi.Input[str]`)
            * `secretKey` (`pulumi.Input[str]`)
        
          * `googleAnalyticsUaId` (`pulumi.Input[str]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `metricsEnabled` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `grafana` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `grafana` (`pulumi.Input[str]`)
        
          * `smtpServer` (`pulumi.Input[dict]`)
        
            * `fromAddress` (`pulumi.Input[str]`)
            * `fromName` (`pulumi.Input[str]`)
            * `host` (`pulumi.Input[str]`)
            * `password` (`pulumi.Input[str]`)
            * `port` (`pulumi.Input[float]`)
            * `skipVerify` (`pulumi.Input[str]`)
            * `username` (`pulumi.Input[str]`)
        
          * `userAutoAssignOrg` (`pulumi.Input[str]`)
          * `userAutoAssignOrgRole` (`pulumi.Input[str]`)
          * `viewersCanEdit` (`pulumi.Input[str]`)
        
        The **influxdb** object supports the following:
        
          * `database_name` (`pulumi.Input[str]`)
        
        The **influxdb_user_config** object supports the following:
        
          * `customDomain` (`pulumi.Input[str]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `influxdb` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `influxdb` (`pulumi.Input[str]`)
        
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **kafka** object supports the following:
        
          * `access_cert` (`pulumi.Input[str]`)
          * `access_key` (`pulumi.Input[str]`)
          * `connectUri` (`pulumi.Input[str]`)
          * `restUri` (`pulumi.Input[str]`)
          * `schemaRegistryUri` (`pulumi.Input[str]`)
        
        The **kafka_connect_user_config** object supports the following:
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `kafka_connect` (`pulumi.Input[dict]`)
        
            * `consumerIsolationLevel` (`pulumi.Input[str]`)
            * `consumerMaxPollRecords` (`pulumi.Input[float]`)
            * `offsetFlushIntervalMs` (`pulumi.Input[float]`)
        
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `kafka_connect` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `kafka_connect` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
        The **kafka_user_config** object supports the following:
        
          * `customDomain` (`pulumi.Input[str]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `kafka` (`pulumi.Input[dict]`)
        
            * `autoCreateTopicsEnable` (`pulumi.Input[str]`)
            * `compressionType` (`pulumi.Input[str]`)
            * `connectionsMaxIdleMs` (`pulumi.Input[float]`)
            * `defaultReplicationFactor` (`pulumi.Input[float]`)
            * `groupMaxSessionTimeoutMs` (`pulumi.Input[float]`)
            * `groupMinSessionTimeoutMs` (`pulumi.Input[float]`)
            * `logCleanerMaxCompactionLagMs` (`pulumi.Input[float]`)
            * `logCleanerMinCleanableRatio` (`pulumi.Input[float]`)
            * `logCleanerMinCompactionLagMs` (`pulumi.Input[float]`)
            * `logMessageTimestampDifferenceMaxMs` (`pulumi.Input[float]`)
            * `logMessageTimestampType` (`pulumi.Input[str]`)
            * `logRetentionBytes` (`pulumi.Input[float]`)
            * `logRetentionHours` (`pulumi.Input[float]`)
            * `logSegmentBytes` (`pulumi.Input[float]`)
            * `maxConnectionsPerIp` (`pulumi.Input[float]`)
            * `messageMaxBytes` (`pulumi.Input[float]`)
            * `numPartitions` (`pulumi.Input[float]`)
            * `offsetsRetentionMinutes` (`pulumi.Input[float]`)
            * `producerPurgatoryPurgeIntervalRequests` (`pulumi.Input[float]`)
            * `replicaFetchMaxBytes` (`pulumi.Input[float]`)
            * `replicaFetchResponseMaxBytes` (`pulumi.Input[float]`)
            * `socketRequestMaxBytes` (`pulumi.Input[float]`)
        
          * `kafkaAuthenticationMethods` (`pulumi.Input[dict]`)
        
            * `certificate` (`pulumi.Input[bool]`)
            * `sasl` (`pulumi.Input[bool]`)
        
          * `kafka_connect` (`pulumi.Input[bool]`)
          * `kafkaConnectConfig` (`pulumi.Input[dict]`)
        
            * `consumerIsolationLevel` (`pulumi.Input[str]`)
            * `consumerMaxPollRecords` (`pulumi.Input[float]`)
            * `offsetFlushIntervalMs` (`pulumi.Input[float]`)
        
          * `kafkaRest` (`pulumi.Input[bool]`)
          * `kafkaRestConfig` (`pulumi.Input[dict]`)
        
            * `consumerEnableAutoCommit` (`pulumi.Input[bool]`)
            * `consumerRequestMaxBytes` (`pulumi.Input[float]`)
            * `consumerRequestTimeoutMs` (`pulumi.Input[float]`)
            * `producerAcks` (`pulumi.Input[str]`)
            * `producerLingerMs` (`pulumi.Input[float]`)
            * `simpleconsumerPoolSizeMax` (`pulumi.Input[float]`)
        
          * `kafkaVersion` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `kafka` (`pulumi.Input[str]`)
            * `kafka_connect` (`pulumi.Input[str]`)
            * `kafkaRest` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
            * `schemaRegistry` (`pulumi.Input[str]`)
        
          * `schemaRegistry` (`pulumi.Input[bool]`)
        
        The **mysql_user_config** object supports the following:
        
          * `adminPassword` (`pulumi.Input[str]`)
          * `adminUsername` (`pulumi.Input[str]`)
          * `backupHour` (`pulumi.Input[float]`)
          * `backupMinute` (`pulumi.Input[float]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `mysql` (`pulumi.Input[dict]`)
        
            * `defaultTimeZone` (`pulumi.Input[str]`)
            * `groupConcatMaxLen` (`pulumi.Input[float]`)
            * `innodbFtMinTokenSize` (`pulumi.Input[float]`)
            * `innodbFtServerStopwordTable` (`pulumi.Input[str]`)
            * `sqlMode` (`pulumi.Input[str]`)
        
          * `mysqlVersion` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `mysql` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `mysql` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `recoveryTargetTime` (`pulumi.Input[str]`)
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **pg** object supports the following:
        
          * `dbname` (`pulumi.Input[str]`)
          * `host` (`pulumi.Input[str]`)
          * `password` (`pulumi.Input[str]`)
          * `port` (`pulumi.Input[float]`)
          * `replicaUri` (`pulumi.Input[str]`)
          * `sslmode` (`pulumi.Input[str]`)
          * `uri` (`pulumi.Input[str]`)
          * `user` (`pulumi.Input[str]`)
        
        The **pg_user_config** object supports the following:
        
          * `adminPassword` (`pulumi.Input[str]`)
          * `adminUsername` (`pulumi.Input[str]`)
          * `backupHour` (`pulumi.Input[float]`)
          * `backupMinute` (`pulumi.Input[float]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `pg` (`pulumi.Input[dict]`)
        
            * `autovacuumAnalyzeScaleFactor` (`pulumi.Input[float]`)
            * `autovacuumAnalyzeThreshold` (`pulumi.Input[float]`)
            * `autovacuumMaxWorkers` (`pulumi.Input[float]`)
            * `autovacuumNaptime` (`pulumi.Input[float]`)
            * `autovacuumVacuumCostDelay` (`pulumi.Input[float]`)
            * `autovacuumVacuumCostLimit` (`pulumi.Input[float]`)
            * `autovacuumVacuumScaleFactor` (`pulumi.Input[float]`)
            * `autovacuumVacuumThreshold` (`pulumi.Input[float]`)
            * `idleInTransactionSessionTimeout` (`pulumi.Input[float]`)
            * `jit` (`pulumi.Input[str]`)
            * `logAutovacuumMinDuration` (`pulumi.Input[float]`)
            * `logErrorVerbosity` (`pulumi.Input[str]`)
            * `logMinDurationStatement` (`pulumi.Input[float]`)
            * `maxLocksPerTransaction` (`pulumi.Input[float]`)
            * `maxParallelWorkers` (`pulumi.Input[float]`)
            * `maxParallelWorkersPerGather` (`pulumi.Input[float]`)
            * `maxPredLocksPerTransaction` (`pulumi.Input[float]`)
            * `maxPreparedTransactions` (`pulumi.Input[float]`)
            * `maxStackDepth` (`pulumi.Input[float]`)
            * `maxStandbyArchiveDelay` (`pulumi.Input[float]`)
            * `maxStandbyStreamingDelay` (`pulumi.Input[float]`)
            * `maxWorkerProcesses` (`pulumi.Input[float]`)
            * `pgStatStatementsTrack` (`pulumi.Input[str]`)
            * `tempFileLimit` (`pulumi.Input[float]`)
            * `timezone` (`pulumi.Input[str]`)
            * `trackActivityQuerySize` (`pulumi.Input[float]`)
            * `trackFunctions` (`pulumi.Input[str]`)
        
          * `pgReadReplica` (`pulumi.Input[str]`)
          * `pgServiceToForkFrom` (`pulumi.Input[str]`)
          * `pgVersion` (`pulumi.Input[str]`)
          * `pgbouncer` (`pulumi.Input[dict]`)
        
            * `serverResetQueryAlways` (`pulumi.Input[bool]`)
        
          * `pglookout` (`pulumi.Input[dict]`)
        
            * `maxFailoverReplicationTimeLag` (`pulumi.Input[float]`)
        
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `pg` (`pulumi.Input[str]`)
            * `pgbouncer` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `pg` (`pulumi.Input[str]`)
            * `pgbouncer` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `recoveryTargetTime` (`pulumi.Input[str]`)
          * `serviceToForkFrom` (`pulumi.Input[str]`)
          * `timescaledb` (`pulumi.Input[dict]`)
        
            * `maxBackgroundWorkers` (`pulumi.Input[float]`)
        
          * `variant` (`pulumi.Input[str]`)
        
        The **redis_user_config** object supports the following:
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `migration` (`pulumi.Input[dict]`)
        
            * `host` (`pulumi.Input[str]`)
            * `password` (`pulumi.Input[str]`)
            * `port` (`pulumi.Input[float]`)
            * `ssl` (`pulumi.Input[bool]`)
            * `username` (`pulumi.Input[str]`)
        
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
            * `redis` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
            * `redis` (`pulumi.Input[str]`)
        
          * `redisLfuDecayTime` (`pulumi.Input[float]`)
          * `redisLfuLogFactor` (`pulumi.Input[float]`)
          * `redisMaxmemoryPolicy` (`pulumi.Input[str]`)
          * `redisNotifyKeyspaceEvents` (`pulumi.Input[str]`)
          * `redisSsl` (`pulumi.Input[bool]`)
          * `redisTimeout` (`pulumi.Input[float]`)
        
        The **service_integrations** object supports the following:
        
          * `integration_type` (`pulumi.Input[str]`)
          * `source_service_name` (`pulumi.Input[str]`)

        > This content is derived from https://github.com/aiven/terraform-provider-aiven/blob/master/website/docs/r/service.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['cassandra'] = cassandra
            __props__['cassandra_user_config'] = cassandra_user_config
            __props__['cloud_name'] = cloud_name
            __props__['elasticsearch'] = elasticsearch
            __props__['elasticsearch_user_config'] = elasticsearch_user_config
            __props__['grafana'] = grafana
            __props__['grafana_user_config'] = grafana_user_config
            __props__['influxdb'] = influxdb
            __props__['influxdb_user_config'] = influxdb_user_config
            __props__['kafka'] = kafka
            __props__['kafka_connect'] = kafka_connect
            __props__['kafka_connect_user_config'] = kafka_connect_user_config
            __props__['kafka_user_config'] = kafka_user_config
            __props__['maintenance_window_dow'] = maintenance_window_dow
            __props__['maintenance_window_time'] = maintenance_window_time
            __props__['mysql'] = mysql
            __props__['mysql_user_config'] = mysql_user_config
            __props__['pg'] = pg
            __props__['pg_user_config'] = pg_user_config
            __props__['plan'] = plan
            if project is None:
                raise TypeError("Missing required property 'project'")
            __props__['project'] = project
            __props__['project_vpc_id'] = project_vpc_id
            __props__['redis'] = redis
            __props__['redis_user_config'] = redis_user_config
            __props__['service_integrations'] = service_integrations
            if service_name is None:
                raise TypeError("Missing required property 'service_name'")
            __props__['service_name'] = service_name
            if service_type is None:
                raise TypeError("Missing required property 'service_type'")
            __props__['service_type'] = service_type
            __props__['termination_protection'] = termination_protection
            __props__['components'] = None
            __props__['service_host'] = None
            __props__['service_password'] = None
            __props__['service_port'] = None
            __props__['service_uri'] = None
            __props__['service_username'] = None
            __props__['state'] = None
        super(Service, __self__).__init__(
            'aiven:index/service:Service',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, cassandra=None, cassandra_user_config=None, cloud_name=None, components=None, elasticsearch=None, elasticsearch_user_config=None, grafana=None, grafana_user_config=None, influxdb=None, influxdb_user_config=None, kafka=None, kafka_connect=None, kafka_connect_user_config=None, kafka_user_config=None, maintenance_window_dow=None, maintenance_window_time=None, mysql=None, mysql_user_config=None, pg=None, pg_user_config=None, plan=None, project=None, project_vpc_id=None, redis=None, redis_user_config=None, service_host=None, service_integrations=None, service_name=None, service_password=None, service_port=None, service_type=None, service_uri=None, service_username=None, state=None, termination_protection=None):
        """
        Get an existing Service resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        
        The **cassandra_user_config** object supports the following:
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `migrateSstableloader` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
        
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **components** object supports the following:
        
          * `component` (`pulumi.Input[str]`)
          * `host` (`pulumi.Input[str]`)
          * `kafkaAuthenticationMethod` (`pulumi.Input[str]`)
          * `port` (`pulumi.Input[float]`)
          * `route` (`pulumi.Input[str]`)
          * `ssl` (`pulumi.Input[bool]`)
          * `usage` (`pulumi.Input[str]`)
        
        The **elasticsearch** object supports the following:
        
          * `kibanaUri` (`pulumi.Input[str]`)
        
        The **elasticsearch_user_config** object supports the following:
        
          * `customDomain` (`pulumi.Input[str]`)
          * `disableReplicationFactorAdjustment` (`pulumi.Input[str]`)
          * `elasticsearch` (`pulumi.Input[dict]`)
        
            * `actionAutoCreateIndexEnabled` (`pulumi.Input[str]`)
            * `actionDestructiveRequiresName` (`pulumi.Input[str]`)
            * `httpMaxContentLength` (`pulumi.Input[float]`)
            * `indicesFielddataCacheSize` (`pulumi.Input[float]`)
            * `indicesMemoryIndexBufferSize` (`pulumi.Input[float]`)
            * `indicesQueriesCacheSize` (`pulumi.Input[float]`)
            * `indicesQueryBoolMaxClauseCount` (`pulumi.Input[float]`)
            * `reindexRemoteWhitelists` (`pulumi.Input[list]`)
            * `threadPoolAnalyzeQueueSize` (`pulumi.Input[float]`)
            * `threadPoolAnalyzeSize` (`pulumi.Input[float]`)
            * `threadPoolForceMergeSize` (`pulumi.Input[float]`)
            * `threadPoolGetQueueSize` (`pulumi.Input[float]`)
            * `threadPoolGetSize` (`pulumi.Input[float]`)
            * `threadPoolIndexQueueSize` (`pulumi.Input[float]`)
            * `threadPoolIndexSize` (`pulumi.Input[float]`)
            * `threadPoolSearchQueueSize` (`pulumi.Input[float]`)
            * `threadPoolSearchSize` (`pulumi.Input[float]`)
            * `threadPoolSearchThrottledQueueSize` (`pulumi.Input[float]`)
            * `threadPoolSearchThrottledSize` (`pulumi.Input[float]`)
            * `threadPoolWriteQueueSize` (`pulumi.Input[float]`)
            * `threadPoolWriteSize` (`pulumi.Input[float]`)
        
          * `elasticsearchVersion` (`pulumi.Input[str]`)
          * `indexPatterns` (`pulumi.Input[list]`)
        
            * `maxIndexCount` (`pulumi.Input[float]`)
            * `pattern` (`pulumi.Input[str]`)
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `kibana` (`pulumi.Input[dict]`)
        
            * `elasticsearchRequestTimeout` (`pulumi.Input[float]`)
            * `enabled` (`pulumi.Input[bool]`)
            * `maxOldSpaceSize` (`pulumi.Input[float]`)
        
          * `maxIndexCount` (`pulumi.Input[float]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `elasticsearch` (`pulumi.Input[str]`)
            * `kibana` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `elasticsearch` (`pulumi.Input[str]`)
            * `kibana` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `recoveryBasebackupName` (`pulumi.Input[str]`)
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **grafana_user_config** object supports the following:
        
          * `alertingEnabled` (`pulumi.Input[str]`)
          * `alertingErrorOrTimeout` (`pulumi.Input[str]`)
          * `alertingNodataOrNullvalues` (`pulumi.Input[str]`)
          * `allowEmbedding` (`pulumi.Input[str]`)
          * `authGithub` (`pulumi.Input[dict]`)
        
            * `allowSignUp` (`pulumi.Input[str]`)
            * `allowedOrganizations` (`pulumi.Input[list]`)
            * `clientId` (`pulumi.Input[str]`)
            * `clientSecret` (`pulumi.Input[str]`)
            * `teamIds` (`pulumi.Input[list]`)
        
          * `authGitlab` (`pulumi.Input[dict]`)
        
            * `allowSignUp` (`pulumi.Input[str]`)
            * `allowedGroups` (`pulumi.Input[list]`)
            * `apiUrl` (`pulumi.Input[str]`)
            * `authUrl` (`pulumi.Input[str]`)
            * `clientId` (`pulumi.Input[str]`)
            * `clientSecret` (`pulumi.Input[str]`)
            * `tokenUrl` (`pulumi.Input[str]`)
        
          * `authGoogle` (`pulumi.Input[dict]`)
        
            * `allowSignUp` (`pulumi.Input[str]`)
            * `allowedDomains` (`pulumi.Input[list]`)
            * `clientId` (`pulumi.Input[str]`)
            * `clientSecret` (`pulumi.Input[str]`)
        
          * `cookieSamesite` (`pulumi.Input[str]`)
          * `customDomain` (`pulumi.Input[str]`)
          * `dashboardsVersionsToKeep` (`pulumi.Input[float]`)
          * `dataproxySendUserHeader` (`pulumi.Input[str]`)
          * `dataproxyTimeout` (`pulumi.Input[float]`)
          * `disableGravatar` (`pulumi.Input[str]`)
          * `editorsCanAdmin` (`pulumi.Input[str]`)
          * `externalImageStorage` (`pulumi.Input[dict]`)
        
            * `access_key` (`pulumi.Input[str]`)
            * `bucketUrl` (`pulumi.Input[str]`)
            * `provider` (`pulumi.Input[str]`)
            * `secretKey` (`pulumi.Input[str]`)
        
          * `googleAnalyticsUaId` (`pulumi.Input[str]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `metricsEnabled` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `grafana` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `grafana` (`pulumi.Input[str]`)
        
          * `smtpServer` (`pulumi.Input[dict]`)
        
            * `fromAddress` (`pulumi.Input[str]`)
            * `fromName` (`pulumi.Input[str]`)
            * `host` (`pulumi.Input[str]`)
            * `password` (`pulumi.Input[str]`)
            * `port` (`pulumi.Input[float]`)
            * `skipVerify` (`pulumi.Input[str]`)
            * `username` (`pulumi.Input[str]`)
        
          * `userAutoAssignOrg` (`pulumi.Input[str]`)
          * `userAutoAssignOrgRole` (`pulumi.Input[str]`)
          * `viewersCanEdit` (`pulumi.Input[str]`)
        
        The **influxdb** object supports the following:
        
          * `database_name` (`pulumi.Input[str]`)
        
        The **influxdb_user_config** object supports the following:
        
          * `customDomain` (`pulumi.Input[str]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `influxdb` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `influxdb` (`pulumi.Input[str]`)
        
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **kafka** object supports the following:
        
          * `access_cert` (`pulumi.Input[str]`)
          * `access_key` (`pulumi.Input[str]`)
          * `connectUri` (`pulumi.Input[str]`)
          * `restUri` (`pulumi.Input[str]`)
          * `schemaRegistryUri` (`pulumi.Input[str]`)
        
        The **kafka_connect_user_config** object supports the following:
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `kafka_connect` (`pulumi.Input[dict]`)
        
            * `consumerIsolationLevel` (`pulumi.Input[str]`)
            * `consumerMaxPollRecords` (`pulumi.Input[float]`)
            * `offsetFlushIntervalMs` (`pulumi.Input[float]`)
        
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `kafka_connect` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `kafka_connect` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
        The **kafka_user_config** object supports the following:
        
          * `customDomain` (`pulumi.Input[str]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `kafka` (`pulumi.Input[dict]`)
        
            * `autoCreateTopicsEnable` (`pulumi.Input[str]`)
            * `compressionType` (`pulumi.Input[str]`)
            * `connectionsMaxIdleMs` (`pulumi.Input[float]`)
            * `defaultReplicationFactor` (`pulumi.Input[float]`)
            * `groupMaxSessionTimeoutMs` (`pulumi.Input[float]`)
            * `groupMinSessionTimeoutMs` (`pulumi.Input[float]`)
            * `logCleanerMaxCompactionLagMs` (`pulumi.Input[float]`)
            * `logCleanerMinCleanableRatio` (`pulumi.Input[float]`)
            * `logCleanerMinCompactionLagMs` (`pulumi.Input[float]`)
            * `logMessageTimestampDifferenceMaxMs` (`pulumi.Input[float]`)
            * `logMessageTimestampType` (`pulumi.Input[str]`)
            * `logRetentionBytes` (`pulumi.Input[float]`)
            * `logRetentionHours` (`pulumi.Input[float]`)
            * `logSegmentBytes` (`pulumi.Input[float]`)
            * `maxConnectionsPerIp` (`pulumi.Input[float]`)
            * `messageMaxBytes` (`pulumi.Input[float]`)
            * `numPartitions` (`pulumi.Input[float]`)
            * `offsetsRetentionMinutes` (`pulumi.Input[float]`)
            * `producerPurgatoryPurgeIntervalRequests` (`pulumi.Input[float]`)
            * `replicaFetchMaxBytes` (`pulumi.Input[float]`)
            * `replicaFetchResponseMaxBytes` (`pulumi.Input[float]`)
            * `socketRequestMaxBytes` (`pulumi.Input[float]`)
        
          * `kafkaAuthenticationMethods` (`pulumi.Input[dict]`)
        
            * `certificate` (`pulumi.Input[bool]`)
            * `sasl` (`pulumi.Input[bool]`)
        
          * `kafka_connect` (`pulumi.Input[bool]`)
          * `kafkaConnectConfig` (`pulumi.Input[dict]`)
        
            * `consumerIsolationLevel` (`pulumi.Input[str]`)
            * `consumerMaxPollRecords` (`pulumi.Input[float]`)
            * `offsetFlushIntervalMs` (`pulumi.Input[float]`)
        
          * `kafkaRest` (`pulumi.Input[bool]`)
          * `kafkaRestConfig` (`pulumi.Input[dict]`)
        
            * `consumerEnableAutoCommit` (`pulumi.Input[bool]`)
            * `consumerRequestMaxBytes` (`pulumi.Input[float]`)
            * `consumerRequestTimeoutMs` (`pulumi.Input[float]`)
            * `producerAcks` (`pulumi.Input[str]`)
            * `producerLingerMs` (`pulumi.Input[float]`)
            * `simpleconsumerPoolSizeMax` (`pulumi.Input[float]`)
        
          * `kafkaVersion` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `kafka` (`pulumi.Input[str]`)
            * `kafka_connect` (`pulumi.Input[str]`)
            * `kafkaRest` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
            * `schemaRegistry` (`pulumi.Input[str]`)
        
          * `schemaRegistry` (`pulumi.Input[bool]`)
        
        The **mysql_user_config** object supports the following:
        
          * `adminPassword` (`pulumi.Input[str]`)
          * `adminUsername` (`pulumi.Input[str]`)
          * `backupHour` (`pulumi.Input[float]`)
          * `backupMinute` (`pulumi.Input[float]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `mysql` (`pulumi.Input[dict]`)
        
            * `defaultTimeZone` (`pulumi.Input[str]`)
            * `groupConcatMaxLen` (`pulumi.Input[float]`)
            * `innodbFtMinTokenSize` (`pulumi.Input[float]`)
            * `innodbFtServerStopwordTable` (`pulumi.Input[str]`)
            * `sqlMode` (`pulumi.Input[str]`)
        
          * `mysqlVersion` (`pulumi.Input[str]`)
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `mysql` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `mysql` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `recoveryTargetTime` (`pulumi.Input[str]`)
          * `serviceToForkFrom` (`pulumi.Input[str]`)
        
        The **pg** object supports the following:
        
          * `dbname` (`pulumi.Input[str]`)
          * `host` (`pulumi.Input[str]`)
          * `password` (`pulumi.Input[str]`)
          * `port` (`pulumi.Input[float]`)
          * `replicaUri` (`pulumi.Input[str]`)
          * `sslmode` (`pulumi.Input[str]`)
          * `uri` (`pulumi.Input[str]`)
          * `user` (`pulumi.Input[str]`)
        
        The **pg_user_config** object supports the following:
        
          * `adminPassword` (`pulumi.Input[str]`)
          * `adminUsername` (`pulumi.Input[str]`)
          * `backupHour` (`pulumi.Input[float]`)
          * `backupMinute` (`pulumi.Input[float]`)
          * `ipFilters` (`pulumi.Input[list]`)
          * `pg` (`pulumi.Input[dict]`)
        
            * `autovacuumAnalyzeScaleFactor` (`pulumi.Input[float]`)
            * `autovacuumAnalyzeThreshold` (`pulumi.Input[float]`)
            * `autovacuumMaxWorkers` (`pulumi.Input[float]`)
            * `autovacuumNaptime` (`pulumi.Input[float]`)
            * `autovacuumVacuumCostDelay` (`pulumi.Input[float]`)
            * `autovacuumVacuumCostLimit` (`pulumi.Input[float]`)
            * `autovacuumVacuumScaleFactor` (`pulumi.Input[float]`)
            * `autovacuumVacuumThreshold` (`pulumi.Input[float]`)
            * `idleInTransactionSessionTimeout` (`pulumi.Input[float]`)
            * `jit` (`pulumi.Input[str]`)
            * `logAutovacuumMinDuration` (`pulumi.Input[float]`)
            * `logErrorVerbosity` (`pulumi.Input[str]`)
            * `logMinDurationStatement` (`pulumi.Input[float]`)
            * `maxLocksPerTransaction` (`pulumi.Input[float]`)
            * `maxParallelWorkers` (`pulumi.Input[float]`)
            * `maxParallelWorkersPerGather` (`pulumi.Input[float]`)
            * `maxPredLocksPerTransaction` (`pulumi.Input[float]`)
            * `maxPreparedTransactions` (`pulumi.Input[float]`)
            * `maxStackDepth` (`pulumi.Input[float]`)
            * `maxStandbyArchiveDelay` (`pulumi.Input[float]`)
            * `maxStandbyStreamingDelay` (`pulumi.Input[float]`)
            * `maxWorkerProcesses` (`pulumi.Input[float]`)
            * `pgStatStatementsTrack` (`pulumi.Input[str]`)
            * `tempFileLimit` (`pulumi.Input[float]`)
            * `timezone` (`pulumi.Input[str]`)
            * `trackActivityQuerySize` (`pulumi.Input[float]`)
            * `trackFunctions` (`pulumi.Input[str]`)
        
          * `pgReadReplica` (`pulumi.Input[str]`)
          * `pgServiceToForkFrom` (`pulumi.Input[str]`)
          * `pgVersion` (`pulumi.Input[str]`)
          * `pgbouncer` (`pulumi.Input[dict]`)
        
            * `serverResetQueryAlways` (`pulumi.Input[bool]`)
        
          * `pglookout` (`pulumi.Input[dict]`)
        
            * `maxFailoverReplicationTimeLag` (`pulumi.Input[float]`)
        
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `pg` (`pulumi.Input[str]`)
            * `pgbouncer` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `pg` (`pulumi.Input[str]`)
            * `pgbouncer` (`pulumi.Input[str]`)
            * `prometheus` (`pulumi.Input[str]`)
        
          * `recoveryTargetTime` (`pulumi.Input[str]`)
          * `serviceToForkFrom` (`pulumi.Input[str]`)
          * `timescaledb` (`pulumi.Input[dict]`)
        
            * `maxBackgroundWorkers` (`pulumi.Input[float]`)
        
          * `variant` (`pulumi.Input[str]`)
        
        The **redis_user_config** object supports the following:
        
          * `ipFilters` (`pulumi.Input[list]`)
          * `migration` (`pulumi.Input[dict]`)
        
            * `host` (`pulumi.Input[str]`)
            * `password` (`pulumi.Input[str]`)
            * `port` (`pulumi.Input[float]`)
            * `ssl` (`pulumi.Input[bool]`)
            * `username` (`pulumi.Input[str]`)
        
          * `privateAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
            * `redis` (`pulumi.Input[str]`)
        
          * `publicAccess` (`pulumi.Input[dict]`)
        
            * `prometheus` (`pulumi.Input[str]`)
            * `redis` (`pulumi.Input[str]`)
        
          * `redisLfuDecayTime` (`pulumi.Input[float]`)
          * `redisLfuLogFactor` (`pulumi.Input[float]`)
          * `redisMaxmemoryPolicy` (`pulumi.Input[str]`)
          * `redisNotifyKeyspaceEvents` (`pulumi.Input[str]`)
          * `redisSsl` (`pulumi.Input[bool]`)
          * `redisTimeout` (`pulumi.Input[float]`)
        
        The **service_integrations** object supports the following:
        
          * `integration_type` (`pulumi.Input[str]`)
          * `source_service_name` (`pulumi.Input[str]`)

        > This content is derived from https://github.com/aiven/terraform-provider-aiven/blob/master/website/docs/r/service.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["cassandra"] = cassandra
        __props__["cassandra_user_config"] = cassandra_user_config
        __props__["cloud_name"] = cloud_name
        __props__["components"] = components
        __props__["elasticsearch"] = elasticsearch
        __props__["elasticsearch_user_config"] = elasticsearch_user_config
        __props__["grafana"] = grafana
        __props__["grafana_user_config"] = grafana_user_config
        __props__["influxdb"] = influxdb
        __props__["influxdb_user_config"] = influxdb_user_config
        __props__["kafka"] = kafka
        __props__["kafka_connect"] = kafka_connect
        __props__["kafka_connect_user_config"] = kafka_connect_user_config
        __props__["kafka_user_config"] = kafka_user_config
        __props__["maintenance_window_dow"] = maintenance_window_dow
        __props__["maintenance_window_time"] = maintenance_window_time
        __props__["mysql"] = mysql
        __props__["mysql_user_config"] = mysql_user_config
        __props__["pg"] = pg
        __props__["pg_user_config"] = pg_user_config
        __props__["plan"] = plan
        __props__["project"] = project
        __props__["project_vpc_id"] = project_vpc_id
        __props__["redis"] = redis
        __props__["redis_user_config"] = redis_user_config
        __props__["service_host"] = service_host
        __props__["service_integrations"] = service_integrations
        __props__["service_name"] = service_name
        __props__["service_password"] = service_password
        __props__["service_port"] = service_port
        __props__["service_type"] = service_type
        __props__["service_uri"] = service_uri
        __props__["service_username"] = service_username
        __props__["state"] = state
        __props__["termination_protection"] = termination_protection
        return Service(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

